
create type datentro as (tot numeric, entro integer, con numeric);


CREATE OR REPLACE FUNCTION trans_c45_mate(varchar,varchar,int) RETURNS SETOF varchar AS '
DECLARE
	
	
BEGIN

	EXECUTE ''SELECT * FROM purify(''''''||$1||'''''')'';
	
	EXECUTE ''SELECT * FROM transform(''''''||$2||'''''')'';
	
	EXECUTE ''SELECT * FROM process_rdm(''''kdd_ent'''',''||$3||'')'';
	
	EXECUTE ''SELECT * FROM filter(''''''||$2||'''''')'';

	RETURN NEXT ''ok'';
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);


CREATE OR REPLACE FUNCTION purify(varchar) RETURNS SETOF varchar AS '

DECLARE
	
	i		integer;
	cont		numeric;
	
	sql		text DEFAULT '''';
	cad		text DEFAULT NULL;
	att		text DEFAULT NULL;
		
	rec1		record;
	rec2		record;
	
BEGIN



	sql := ''SELECT attname,typname FROM pg_class, pg_attribute,pg_type''
		|| '' WHERE pg_class.relname = ''''''||$1||''''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND pg_type.oid=pg_attribute.atttypid AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		IF cad ISNULL THEN
			cad := rec1.attname||'' ''||rec1.typname;	
			
		ELSE	
			cad := cad ||'',''|| rec1.attname||'' ''||rec1.typname;
			
		END IF;
	
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''kdd_list'''''' LOOP
		EXECUTE ''DROP TABLE kdd_list'';	
	END LOOP;
		
	EXECUTE ''CREATE TABLE kdd_list(''||cad||'')'';	
	
	EXECUTE ''INSERT INTO kdd_list SELECT * FROM ''||$1;



	
	sql := ''SELECT attname, atttypid FROM pg_class, pg_attribute WHERE pg_class.relname = ''''kdd_list''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		FOR rec2 IN EXECUTE ''SELECT COUNT(*) AS cc FROM kdd_list WHERE ''||rec1.attname||'' IS NULL'' LOOP
			cont := rec2.cc;
		END LOOP;
		
		IF cont > 0 THEN
		RAISE NOTICE ''%  %'',rec1.attname,rec1.atttypid;
			IF rec1.atttypid = 20 OR rec1.atttypid = 21 OR rec1.atttypid = 22 OR rec1.atttypid = 23 OR rec1.atttypid = 700 OR rec1.atttypid = 1700 OR rec1.atttypid = 701 THEN
			   
			   sql := ''SELECT ''||rec1.attname||'' AS vl FROM kdd_list WHERE ''||rec1.attname||'' IS NOT NULL'';
			   cont := 0;
			   FOR rec2 IN EXECUTE sql LOOP
			   	cont := cont + rec2.vl;
			   END LOOP;
			   
			   sql := ''SELECT COUNT(*) AS cc FROM kdd_list WHERE ''||rec1.attname||'' IS NOT NULL'';
			   FOR rec2 IN EXECUTE sql LOOP
			   	cont := cont / rec2.cc;
			   END LOOP;
			   
			   sql := ''UPDATE kdd_list SET ''||rec1.attname||''=''||cont||'' WHERE ''||rec1.attname||'' IS NULL'';
			   EXECUTE sql;
			
			ELSE
			   
			   sql := ''SELECT ''||rec1.attname||'' AS nm,COUNT(*) AS cc FROM kdd_list WHERE ''||rec1.attname||'' IS NOT NULL GROUP BY ''||rec1.attname;
			   cont := 0;
			   FOR rec2 IN EXECUTE sql LOOP
			   	IF rec2.cc > cont THEN
					cont := rec2.cc;
					att := rec2.nm;
				END IF;
			   END LOOP;
			   
			   sql := ''UPDATE kdd_list SET ''||rec1.attname||''=''''''||att||'''''' WHERE ''||rec1.attname||'' IS NULL'';
			   EXECUTE sql;
			
			END IF;
		END IF;
	
	END LOOP;	
	
	RETURN NEXT ''CREADA LA TABLA kdd_list'';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);


CREATE OR REPLACE FUNCTION transform(varchar) RETURNS SETOF varchar AS ' 


DECLARE
	
	i		integer;
	j		integer;	
		
	qry_sql		text DEFAULT '''';
	qry_sql2	text DEFAULT '''';
	qry_sql3	text DEFAULT '''';
	cad_var		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	cad_int		text DEFAULT NULL;	
	flag_val	text DEFAULT NULL;
	
	rec_at		record;	
	rec_att		record;		
	
BEGIN



	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_list'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid AND attname!=''''''||$1;
	qry_sql := qry_sql || '''''' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		IF cad_var ISNULL THEN
			cad_var := rec_at.attname||'' bpchar'';
			cad_int := rec_at.attname||'' int2'';
			cad := rec_at.attname;
			
		ELSE
			
			cad_var := cad_var ||'' , ''|| rec_at.attname||'' bpchar'';
			cad_int := cad_int ||'' , ''|| rec_at.attname||'' int2'';
			cad := cad || '','' || rec_at.attname;
		END IF;
	
	END LOOP;	
	cad_var := cad_var || '','' || $1 || '' bpchar'';
	cad_int := cad_int || '',''|| $1 || '' int'';
	cad := cad || '','' || $1;
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''kdd_ent'';
	IF flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE kdd_ent'';	
	END IF;
	
	EXECUTE ''CREATE TABLE kdd_ent (''||cad_var||'')'';
	EXECUTE ''INSERT INTO kdd_ent SELECT ''||cad||'' FROM kdd_list'';
	
	
	

	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''kdd_values'';
	IF flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE kdd_values'';
	END IF; 
	EXECUTE ''CREATE TABLE kdd_values(nro int2,atributo varchar,valor varchar,discret varchar,nclases int2)'';
		
	j=1;
	qry_sql := ''SELECT attname FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 AND attnum <= relnatts ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
		
		i := 0;
		qry_sql2 := ''SELECT DISTINCT ''||rec_at.attname||'' AS val FROM kdd_ent '';
		qry_sql2 := qry_sql2 || ''WHERE ''||rec_at.attname||'' IS NOT NULL GROUP BY val'';
		
		FOR rec_att IN EXECUTE qry_sql2 LOOP
			
			qry_sql3 := ''INSERT INTO kdd_values (nro,atributo,valor,discret) VALUES ''; 
			qry_sql3 := qry_sql3 || ''(''||j||'',''''''||rec_at.attname||'''''',''''''||rec_att.val||'''''',''''''||i||'''''')'';
			EXECUTE qry_sql3;
			i := i + 1;
			j := j + 1;
			
		END LOOP;
		
		qry_sql3 := ''UPDATE kdd_values SET nclases = ''||i||'' WHERE nro = ''||j-1;
		EXECUTE qry_sql3;
		
	END LOOP;
		


	
	FOR rec_at IN EXECUTE ''SELECT atributo,valor,discret FROM kdd_values'' LOOP
		
		qry_sql := ''UPDATE kdd_ent SET ''||rec_at.atributo||'' = ''||rec_at.discret||''''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' = ''''''||rec_at.valor||'''''''';
		EXECUTE qry_sql;
		
		qry_sql := ''UPDATE kdd_ent SET ''||rec_at.atributo||'' = -1''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' IS NULL'';
		EXECUTE qry_sql;
		
	END LOOP;
	
	EXECUTE ''COPY kdd_ent TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE kdd_ent'';
	EXECUTE ''CREATE TABLE kdd_ent (''||cad_int||'')''; 
	EXECUTE ''COPY kdd_ent FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	
	EXECUTE ''DROP TABLE kdd_list'';	
		
	RETURN NEXT ''CREATE TABLE kdd_values'';
	RETURN NEXT ''CREATE TABLE kdd_ent'';
	RETURN;

END;'
LANGUAGE 'plpgsql' WITH (isstrict);


CREATE OR REPLACE FUNCTION process_rdm(varchar,integer) RETURNS SETOF varchar AS '


DECLARE
	
	i		integer;
	cont		integer;
	rm		numeric;
	ban		integer = 0;
	
	tabla		varchar DEFAULT NULL;
	sql		varchar DEFAULT NULL;
	cad		varchar DEFAULT NULL;
		
	rec1		record;		
	rec2		record;		
	
BEGIN
	IF $1 = ''kdd_ent'' THEN
		tabla := ''kdd_pru'';
	ELSE
		tabla := ''pg_col'';
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''kdd_ent'''''' LOOP	
		EXECUTE ''DROP TABLE kdd_ent'';	
		END LOOP;
		EXECUTE ''CREATE TABLE kdd_ent AS SELECT * FROM ''||$1;
	END IF;
	cont := $2;	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
		EXECUTE ''DROP TABLE ''||tabla;	
	END LOOP;
	i :=0;
	WHILE i < cont LOOP
		FOR rec1 IN EXECUTE ''SELECT oid FROM kdd_ent'' LOOP
			FOR rec2 IN EXECUTE ''SELECT * FROM random()'' LOOP				
				rm := rec2.random;
			END LOOP;			
			IF i< cont THEN
				IF rm < 0.5 THEN
					IF i = 0 THEN
						EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM kdd_ent WHERE oid=''||rec1.oid;
					ELSE
						EXECUTE ''INSERT INTO ''||tabla||'' SELECT * FROM kdd_ent WHERE oid=''||rec1.oid;
					END IF;
					i := i + 1;				
					EXECUTE ''DELETE FROM kdd_ent WHERE oid=''||rec1.oid;		
				END IF;
			END IF;
		END LOOP;				
	END LOOP;

	IF $1 <> ''kdd_ent'' THEN
		sql := ''SELECT attname,typname FROM pg_class, pg_attribute,pg_type''
			|| '' WHERE pg_class.relname = ''''''||$1||''''''''
			|| '' AND pg_type.oid = atttypid AND pg_attribute.attrelid = pg_class.oid AND attnum>0 ORDER BY attnum'';
		
		FOR rec1 IN EXECUTE sql LOOP
			IF cad ISNULL THEN
				cad := rec1.attname||'' ''||rec1.typname;
			ELSE
				cad := cad ||'',''||rec1.attname||'' ''||rec1.typname;
			END IF;
		END LOOP;	
		tabla := ''fl_''||$1;		
		EXECUTE ''COPY pg_col TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
		EXECUTE ''DROP TABLE pg_col'';
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
			EXECUTE ''DROP TABLE ''||tabla;	
		END LOOP;
		EXECUTE ''CREATE TABLE ''||tabla||'' (''||cad||'')''; 
		EXECUTE ''COPY ''||tabla||'' FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
		EXECUTE ''DROP TABLE kdd_ent'';
	END IF;	
	
	RETURN NEXT tabla;	
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION filter(varchar) RETURNS SETOF varchar AS '
DECLARE
	
	i		integer;	
	
	sql		text DEFAULT '''';
	sql1		text DEFAULT '''';
	attb		text DEFAULT NULL;
	cad		text DEFAULT NULL;
	clase		text DEFAULT NULL;
	tabla		bpchar DEFAULT NULL;
		
	rec1		record;	
	rec2		record;	
	rec3		record;	
	
	p_may		numeric;
	pb		numeric;
	
BEGIN



	tabla = ''pg_kdd_tmp'';	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''''||tabla||'''''''' LOOP	
		EXECUTE ''DROP TABLE ''||tabla;	
	END LOOP;
	EXECUTE ''CREATE TABLE ''||tabla||'' AS SELECT * FROM kdd_ent'';
	
	sql := ''SELECT attname FROM pg_class, pg_attribute WHERE pg_class.relname = ''''kdd_ent''''''
		|| '' AND pg_attribute.attrelid = pg_class.oid AND attname!=''''''||$1
		|| '''''' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
		IF attb IS NULL THEN
			attb := rec1.attname;
		ELSE
			attb := attb ||'',''|| rec1.attname;
		END IF;
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname =''''pg_tmp_kdd'''''' LOOP	
		EXECUTE ''DROP TABLE pg_tmp_kdd'';	
	END LOOP;
 	EXECUTE ''CREATE TABLE pg_tmp_kdd AS SELECT ''||attb||'',COUNT(*) AS cc FROM kdd_ent GROUP BY ''||attb;
		
	FOR rec1 IN EXECUTE ''SELECT ctid,cc FROM pg_tmp_kdd'' LOOP		
		cad := NULL;
		sql := ''SELECT attname,atttypid FROM pg_class, pg_attribute''
			|| '' WHERE pg_class.relname = ''''kdd_ent''''''
			|| '' AND pg_attribute.attrelid = pg_class.oid AND attname!=''''''||$1||''''''''
			|| '' AND attnum > 0 ORDER BY attnum'';
			
		FOR rec2 IN EXECUTE sql LOOP
			sql1 := rec1.ctid;
			sql1:=''SELECT ''||rec2.attname||'' AS at FROM pg_tmp_kdd WHERE ctid=''''''||sql1||'''''''';

			FOR rec3 IN EXECUTE sql1 LOOP
				IF rec2.atttypid = 20 OR rec2.atttypid = 21 OR rec2.atttypid = 22 OR rec2.atttypid = 23 OR rec2.atttypid = 700 OR rec2.atttypid = 1700 OR rec2.atttypid = 701 THEN
			   		
					IF cad ISNULL THEN
						cad := rec2.attname||''=''||rec3.at;
					ELSE	
						cad := cad ||'' AND ''||rec2.attname||''=''||rec3.at;
					END IF;
				ELSE
			   		IF cad ISNULL THEN
						cad := rec2.attname||''=''''''||rec3.at||'''''''';
					ELSE
						cad := cad ||'' AND ''||rec2.attname
							||''=''''''||rec3.at||'''''''';
					END IF;
				END IF;
			END LOOP;			
		END LOOP;
		p_may := 0;
		i := 0;
		sql := ''SELECT COUNT(*) AS ct,''||$1||'' as cs FROM kdd_ent WHERE ''||cad||'' GROUP BY ''
			||attb||'',''||$1;
			
		FOR rec2 IN EXECUTE sql LOOP
			pb := CAST(rec2.ct as numeric)/CAST(rec1.cc as numeric);
			
			IF pb > p_may THEN
				p_may := pb;
				
				clase := CAST(rec2.cs as varchar);
			END IF;
			i := i + 1;
		END LOOP;
		
		IF i > 1 THEN
			EXECUTE ''DELETE FROM kdd_ent WHERE ''||cad||'' AND ''||$1||''!=''''''
				||clase||'''''''';
		END IF;
	END LOOP;
	
	EXECUTE ''DROP TABLE pg_tmp_kdd'';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION matetree(varchar) RETURNS SETOF varchar AS' 
DECLARE
	i		integer;  
	numatt	integer;	
	nodo		integer; 
	ban		integer;  
	cp		integer;  
	
		
	Ent		numeric;	
	Ent_clase	numeric;	
	Gan		numeric;
	G_min		numeric :=999;
	
	sql		text DEFAULT '''';
	sql_g		text DEFAULT '''';	
	txt		text DEFAULT '''';
	rta		text DEFAULT NULL;
			
	rec1		record;
	rec2		record;	
	
BEGIN



	
	EXECUTE ''SELECT * FROM mateby(''''''||$1||'''''')'';
	FOR rec1 IN EXECUTE ''SELECT * FROM entro(''''''||$1||'''''')'' LOOP
		Ent_clase := CAST(rec1.entro as numeric);
	END LOOP;
IF Ent_clase > 0 THEN


	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''mate_rules'''''' LOOP
		EXECUTE ''DROP TABLE mate_rules'';
	END LOOP;		
	EXECUTE ''CREATE TABLE mate_rules (id int2, atributo int2,valor int2)'';	



	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_pila'''''' LOOP
		EXECUTE ''DROP TABLE pg_pila'';
	END LOOP;		
	EXECUTE ''CREATE TABLE pg_pila(num int2, nn int2, att varchar, valor int2)'';	
	EXECUTE ''INSERT INTO pg_pila VALUES(0,0,''''''||$1||'''''',-1)'';


	
	EXECUTE ''SELECT * FROM view_set(''''kdd_entro'''')'';	
	


		sql := ''SELECT attname,attnum FROM pg_class,pg_attribute WHERE ''
			 ||''pg_class.relname=''''kdd_ent''''''	
			 || '' AND pg_attribute.attrelid =  pg_class.oid AND attname !=''''''
			 || $1 || '''''' AND attnum >0 ORDER BY attnum'';
		

		--Creacin tabla Ganancias
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''ganancias'''''' LOOP
			EXECUTE ''DROP TABLE ganancias'';
		END LOOP;
			
		EXECUTE ''CREATE TABLE ganancias(atributo varchar, clase varchar, ganancia numeric)'';

		FOR rec1 IN EXECUTE sql LOOP
		
			EXECUTE ''INSERT INTO pg_pila VALUES(1,0,'''''' || rec1.attname || '''''',-1)'';
			
			sql_g := ''SELECT * FROM mate_gain(0,''''''||$1||'''''')'';
			
			FOR rec2 IN EXECUTE sql_g LOOP
				Gan := rec2.mate_gain; 
				--insert a la tabla ganancias
				EXECUTE ''INSERT INTO ganancias VALUES('''''' || rec1.attname || '''''',''''''|| $1 || '''''',''''''|| Gan ||'''''')'';
			END LOOP;
						
			IF Gan < G_min THEN				
				G_min := Gan;
				txt := rec1.attname;
				numatt := rec1.attnum;
			END IF;	
			
			EXECUTE ''DELETE FROM pg_pila WHERE num=1'';
		END LOOP;		
		cp := 0;


	
		FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''mate_nodes'''''' LOOP
			EXECUTE ''DROP TABLE mate_nodes'';	
		END LOOP;
				
		EXECUTE ''CREATE TABLE mate_nodes (nodo int2,padre int2,atributo bpchar,valor int2,hijo int2, herm int2,clase int2)'';

		EXECUTE ''INSERT INTO mate_nodes VALUES(0,-1,'''''' || txt || '''''',-1,-1,-1,-1)'';
		i := 0;

		FOR rec1 IN EXECUTE ''SELECT  ''||txt||'' AS at FROM kdd_ent GROUP BY ''||txt LOOP		
			i := i + 1;
				EXECUTE ''INSERT INTO mate_nodes VALUES(''||i||'',0,'''''' || txt || '''''',''
					||rec1.at||'',-1,''||(i+1)||'',-1)'';				
		END LOOP;		
		EXECUTE ''UPDATE mate_nodes SET herm = -1 WHERE nodo=''||i;

		ban := 1;
		nodo := 1;
		WHILE (ban != 0) LOOP		
			IF ban = 1 THEN
				FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo = ''||nodo LOOP
					numatt := rec1.hijo;
					cp := cp +1;
					EXECUTE ''INSERT INTO pg_pila VALUES(''||cp||'',''||rec1.nodo||'',''''''||rec1.atributo||'''''',''||rec1.valor||'')'';
				END LOOP;		

				WHILE (numatt != -1) LOOP
					nodo := rec1.hijo;
					FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo = ''||nodo LOOP
						numatt := rec1.hijo;
						cp := cp +1;
						EXECUTE ''INSERT INTO pg_pila VALUES(''||cp||'',''||rec1.nodo||'',''''''||rec1.atributo||'''''',''||rec1.valor||'')'';
					END LOOP;
				END LOOP;

				FOR rec1 IN EXECUTE ''SELECT * FROM mate_tree('' || i || '',''||cp||'',''||nodo||'',''''''||$1||'''''')'' LOOP
					ban := rec1.mate_tree;
				END LOOP;	
                        	FOR rec1 IN EXECUTE ''SELECT max(nodo) AS mx FROM mate_nodes'' LOOP
					i := rec1.mx;
				END LOOP;	
				cp := cp -1;		
			END IF;
			IF ban = 2 THEN
				FOR rec1 IN EXECUTE ''SELECT * FROM mate_nodes WHERE nodo = ''||nodo LOOP
					numatt := rec1.herm;
				END LOOP;
				IF numatt != -1 THEN
					nodo := numatt;
					ban := 1;
				ELSE
					IF cp = 0  THEN
						ban := 0;
					ELSE
						FOR rec1 IN EXECUTE ''SELECT * FROM pg_pila WHERE num = ''||cp LOOP
							nodo := rec1.nn;
							EXECUTE ''DELETE FROM pg_pila WHERE num=''||cp;
							cp := cp - 1;
						END LOOP;
					END IF;
				END IF;
			END IF;			
		END LOOP;		
		
		
		EXECUTE ''DROP TABLE pg_pila'';
		EXECUTE ''DROP VIEW viewc1'';
		
		RETURN NEXT ''mate_rules'';
		RETURN NEXT ''mate_nodes'';
	
	ELSE
		RETURN NEXT ''LA ENTROPIA NO ES IGUAL A CERO'';
		
	END IF;

	
RETURN;

END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION mateby(varchar) RETURNS SETOF varchar AS ' 
DECLARE
	sql		text DEFAULT '''';	
	sql1		text DEFAULT '''';	
	cad		text DEFAULT NULL;	
	cada		text DEFAULT '''';
	qry_sql		text DEFAULT '''';
	
	rec1		record;	
	rec2		record;	
	rec3		record;	
	rec_at		record;	
	
	flag_val	integer;	
	localset	integer;
	attr		integer;
	active		integer;
	control1	integer;
	control2	integer;
	control3	integer;
	flag		integer;
	i		integer;
	num		integer;
	machete		integer;
	
BEGIN	

	

	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_columna'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_columna'';	
	END IF;
	EXECUTE ''CREATE TABLE pg_columna(num int2,att bpchar)'';		

	
	sql1 := ''SELECT attname,relnatts FROM pg_class, pg_attribute'';
	sql1 := sql1 || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	sql1 := sql1 || '' AND pg_attribute.attrelid = pg_class.oid'';
	sql1 := sql1 || '' AND attnum > 0 AND attname != ''''''||$1||'''''''';
	sql1 := sql1 || '' ORDER BY attnum'';
	
	i := 1;
	
	FOR rec1 IN EXECUTE sql1 LOOP	
		IF cad ISNULL THEN
			cad := rec1.attname ||'' bpchar'';
			cada := rec1.attname;
			
			EXECUTE ''INSERT INTO pg_columna VALUES(''||i||'',''''''||rec1.attname||'''''')'';	
			
		ELSE
			cad := cad ||'',''|| rec1.attname || '' bpchar'';
			cada := cada ||'',''||rec1.attname;
			
			EXECUTE ''INSERT INTO pg_columna VALUES(''||i||'',''''''||rec1.attname||'''''')'';	
		END IF;
		attr := rec1.relnatts;
		i := i + 1;
	END LOOP;
	
	cada := cada ||'',''||$1;	
	
	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_mate'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_mate'';	
	END IF;
	
	sql := ''CREATE TABLE pg_mate('' || cad || '','' || $1 || '' bpchar)'';		
	EXECUTE sql;
	


	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''kdd_clase'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE kdd_clase'';	
	END IF;
	
	sql := ''CREATE TABLE kdd_clase('' || cad || '','' || $1;
	sql := sql || '' bpchar,count numeric)'';	
	EXECUTE sql;
	
	
	
	

	
	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_pos'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_pos'';	
	END IF;
	EXECUTE ''CREATE TABLE pg_pos(n int2,pos int2)'';


	
	FOR rec1 IN EXECUTE ''SELECT relname AS flag_val FROM pg_class WHERE relname =''''pg_att'''''' LOOP
	END LOOP;
	IF rec1.flag_val IS NOT NULL THEN
		EXECUTE ''DROP TABLE pg_att'';	
	END IF;
	EXECUTE ''CREATE TABLE pg_att(att bpchar)'';


	
	attr := attr - 1;
	localset := 1;
	
	WHILE localset <= attr LOOP 
		
		active := 0;
		
		EXECUTE ''SELECT * FROM controlposicion(0,''||localset||'',0)'';
		
		active := localset - 1;
		
		FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=0'' LOOP
			control1 := rec2.pos; 
		END LOOP;
		
		machete := 0;
		
		WHILE (control1 < attr - (localset-1)) LOOP 
		
		
		
			FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||active LOOP
				control2 := rec2.pos; 
			END LOOP;	
			
			WHILE (control2 < attr) LOOP 
			
				flag := 1;
				
				i := 0;
				
				WHILE (i < localset AND flag = 1) LOOP	
				
					FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||i LOOP
					END LOOP;
					num := rec2.pos;
					
					FOR rec2 IN EXECUTE ''SELECT att FROM pg_columna WHERE num=''||(num+1) LOOP
					END LOOP;
					
					sql := ''INSERT INTO pg_att VALUES(''''''||rec2.att||'''''')'';	
					
					IF rec2.att IS NULL THEN
						flag := 0;
					ELSE
						EXECUTE sql;	
					END IF;
					
					i := i + 1;	
				END LOOP;
					
				IF flag = 1 THEN
				
					sql := NULL;
					sql1 := NULL;
					
					FOR rec2 IN EXECUTE ''SELECT att FROM pg_att'' LOOP
					
						IF sql IS NULL THEN
							sql := ''INSERT INTO pg_mate('' || rec2.att;
							sql1 := '' SELECT ''||rec2.att;
						ELSE
							sql := sql ||'','' || rec2.att;
							sql1 := sql1 ||'',''||rec2.att;
						END IF;	
						
					END LOOP;
					
					sql := sql || '','' || $1 || '')'';
					sql1 := sql1 || '',''|| $1 || '' FROM kdd_ent'';
					
					sql := sql || sql1;
					
					EXECUTE sql;	
					
					EXECUTE ''DELETE FROM pg_att'';
					
					
				END IF;
				
				control2 := control2 + 1;
				EXECUTE ''UPDATE pg_pos SET pos = ''||control2||'' WHERE n=''||active;
				
			END LOOP; 
			
			IF active > 0 THEN
				
				control2 := control2 - 1;
				EXECUTE ''UPDATE pg_pos SET pos = ''||control2||'' WHERE n=''||active;
				
				FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||(active-1) LOOP				
				END LOOP;
				control3 := rec2.pos + 1;	
				
				WHILE (active > 0 AND ((control3 + 1)>control2)) LOOP
					
					active := active - 1;
					
					FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||active LOOP					
					END LOOP;
					control2 := rec2.pos;
					
					FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||(active-1) LOOP					
					END LOOP;
					control3 := rec2.pos + 1;
					
				END LOOP;
				
				IF active > 0 THEN
					active := active - 1;
				END IF;
				
				
				FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=''||active LOOP
				END LOOP;
				control2 := rec2.pos + 1;
				
				EXECUTE ''SELECT * FROM controlposicion(''||control2||'',''||localset||'',''||active||'')'';
				
				active := localset - 1;
				
			END IF;
			
			FOR rec2 IN EXECUTE ''SELECT pos FROM pg_pos WHERE n=0'' LOOP
			END LOOP;
			control1 := rec2.pos;
			
			
		END LOOP; 
	
		localset := localset + 1;
		
	END LOOP;
	
	EXECUTE ''INSERT INTO kdd_clase(''||cada||'',count) SELECT ''||cada||'',count(*) FROM pg_mate GROUP BY ''||cada;

	

	FOR rec_at IN EXECUTE ''SELECT atributo,valor,discret FROM kdd_values'' LOOP
		
		qry_sql := ''UPDATE tablemate SET ''||rec_at.atributo||'' = ''||rec_at.discret||''''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' = ''''''||rec_at.valor||'''''''';
		EXECUTE qry_sql;
		
		qry_sql := ''UPDATE tablemate SET ''||rec_at.atributo||'' = -1''; 
		qry_sql := qry_sql || '' WHERE ''||rec_at.atributo||'' IS NULL'';
		EXECUTE qry_sql;
		
	END LOOP;

	EXECUTE ''DROP TABLE pg_columna'';
	EXECUTE ''DROP TABLE pg_pos'';
	EXECUTE ''DROP TABLE pg_att'';
	EXECUTE ''DROP TABLE pg_mate'';

	
	EXECUTE ''select * from convertir_mate()''; 
	
	RETURN NEXT ''CREADA kdd_clase'';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION controlposicion(integer,integer,integer) RETURNS SETOF varchar AS '
DECLARE
	sql		text DEFAULT '''';	
	
	rec1		record;	
		
	i		integer;
	j		integer;
	desde		integer;
	donde		integer;
	cuantos		integer;	
	
BEGIN	

	j := $3;
	donde := $3;
	cuantos := $2;
	desde := $1;
	
	
	
	
	
	
	
	
	i := 0;
	
	WHILE i < (cuantos-donde) LOOP
		
		FOR rec1 IN EXECUTE ''SELECT count(*) AS cc FROM pg_pos WHERE n=''||j LOOP
		END LOOP;
		
		IF rec1.cc = 0 THEN
			
			EXECUTE ''INSERT INTO pg_pos VALUES('' || j || '','' || desde || '')'';	
			
		ELSE
			EXECUTE ''UPDATE pg_pos SET pos=''||desde||'' WHERE n=''||j;
		END IF;
		
		desde := desde + 1;
		
		
		j := j + 1;
		i := i + 1;
	END LOOP;
	RETURN NEXT ''OK'';
	RETURN ;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);

CREATE OR REPLACE FUNCTION convertir_mate() RETURNS SETOF varchar AS '
DECLARE
	sql		text DEFAULT '''';	
	sql1		text DEFAULT '''';	
	cad		text DEFAULT '''';	
	cada		text DEFAULT '''';
	
	rec1		record;	
	rec2		record;	
	rec3		record;	
BEGIN
	sql1 := ''SELECT attname,relnatts FROM pg_class, pg_attribute'';
	sql1 := sql1 || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	sql1 := sql1 || '' AND pg_attribute.attrelid = pg_class.oid'';
	sql1 := sql1 || '' AND attnum > 0 ORDER BY attnum'';

	sql := ''SELECT atributo, valor, discret FROM kdd_values'';
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''tablemate_aux'''''' LOOP
		EXECUTE ''DROP TABLE tablemate_aux'';
	END LOOP;

	EXECUTE ''CREATE TABLE tablemate_aux AS SELECT * FROM tablemate'';

	FOR rec1 IN EXECUTE sql1 LOOP	
				
		FOR rec2 IN EXECUTE sql LOOP
			
			IF cast(rec2.atributo as varchar) = cast(rec1.attname as varchar) THEN

				cad := ''UPDATE tablemate_aux set ''||cast(rec1.attname as varchar)||'' = ''''''||cast(rec2.discret as varchar)||'''''''';
				cad := cad ||'' WHERE ''||rec1.attname||'' = ''''''||rec2.valor||'''''''';
				
				EXECUTE cad;	
			END IF;
		END LOOP;
		
	END LOOP;

	EXECUTE ''DELETE FROM kdd_clase'';
	EXECUTE ''INSERT INTO kdd_clase SELECT * FROM tablemate_aux'';
	EXECUTE ''DROP TABLE tablemate_aux'';
	
	RETURN NEXT ''OK'';
	RETURN;

END;'
LANGUAGE 'plpgsql' WITH (isstrict);

CREATE OR REPLACE FUNCTION entro(varchar) RETURNS SETOF numeric AS '
DECLARE
	cont	integer DEFAULT 0;
			
	val_ln2		numeric := 0.69314718055994530942; 
	val_fraccion	numeric;
	val_entro	numeric;
	
	sql		text DEFAULT '''';
	cad		text DEFAULT NULL;
	cad1		text DEFAULT NULL;
	join	text DEFAULT NULL;
		
	
	rec1		record;
	rec2		record;
	rec3		record;
	
BEGIN



	FOR rec1 IN EXECUTE ''SELECT atributo,valor,discret FROM kdd_values'' LOOP		
		sql := ''UPDATE kdd_clase SET ''||rec1.atributo||'' = -1''; 
		sql := sql || '' WHERE ''||rec1.atributo||'' IS NULL'';
		EXECUTE sql;		
	END LOOP;


	
	sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute''
		 || '' WHERE pg_class.relname = ''''kdd_ent''''''
	 	|| '' AND pg_attribute.attrelid = pg_class.oid''
		|| '' AND attname !=''''''||$1||''''''''
		|| '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec1 IN EXECUTE sql LOOP
	
		IF cad ISNULL THEN
			cad := ''t1.''||rec1.attname;
			join := ''t1.''||rec1.attname||'' = t2.''||rec1.attname;
		ELSE
			cad := cad ||'',t1.''|| rec1.attname;
			join := join ||'' AND ''|| ''t1.''||rec1.attname||'' = t2.''||rec1.attname;
		END IF;
	
	END LOOP;
		
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''mate_entro'''''' LOOP
		EXECUTE ''DROP TABLE mate_entro'';
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_entro'''''' LOOP
		EXECUTE ''DROP TABLE kdd_entro'';
	END LOOP;
	

	EXECUTE ''CREATE TABLE mate_entro AS SELECT ''||cad||'' FROM kdd_clase t1 GROUP BY ''||cad;	
	EXECUTE ''ALTER TABLE kdd_clase ADD COLUMN entro numeric(4,4)'';
	

	
	FOR rec3 IN EXECUTE ''SELECT ctid FROM mate_entro'' LOOP
		
		cad1 := rec3.ctid;
		
		sql := ''SELECT SUM(t1.count) AS sum FROM kdd_clase t1, mate_entro t2 WHERE ''||join||'' AND t2.ctid=''''''||cad1||'''''''';
		
		
		FOR rec1 IN EXECUTE sql LOOP
			cont:= rec1.sum;		
			val_entro := 0;
			FOR rec2 IN EXECUTE ''SELECT t1.count AS con, t1.ctid AS t FROM kdd_clase t1, mate_entro t2 WHERE ''||join||'' AND t2.ctid=''''''||cad1||'''''''' LOOP
				val_fraccion := CAST(rec2.con as numeric)/CAST(cont as numeric); 
				val_entro := (((val_fraccion) * ln(val_fraccion))/val_ln2) * -1;
				cad1 := rec2.t;
				EXECUTE ''UPDATE kdd_clase SET entro=''||val_entro||'' WHERE ctid=''''''||cad1||'''''''';
			END LOOP;			
		END LOOP;
		
	END LOOP;
	
	EXECUTE ''DROP TABLE mate_entro'';
	EXECUTE ''CREATE TABLE mate_entro AS SELECT * FROM kdd_clase'';
	
		
	FOR rec1 IN EXECUTE ''SELECT count(*) AS con FROM kdd_ent'' LOOP
	END LOOP;

	cont := rec1.con;
	sql := ''SELECT count(*) AS cc FROM kdd_ent GROUP BY '' || $1;
	val_entro :=0;

	FOR rec1 IN EXECUTE sql LOOP
		val_fraccion := CAST(rec1.cc as numeric)/CAST(cont as numeric);
		val_entro := val_entro - (((val_fraccion) * ln(val_fraccion))/val_ln2);		
	END LOOP;
	
	EXECUTE ''CREATE TABLE kdd_entro AS SELECT * FROM kdd_ent'';
	EXECUTE ''DELETE FROM kdd_entro'';
	EXECUTE ''ALTER TABLE kdd_entro ADD COLUMN count numeric'';
	EXECUTE ''ALTER TABLE kdd_entro ADD COLUMN entro numeric'';
	EXECUTE ''COPY mate_entro TO ''''/tmp/classe.txt'''' using delimiters '''','''''';
	EXECUTE ''DROP TABLE mate_entro'';
	EXECUTE ''COPY kdd_entro FROM ''''/tmp/classe.txt'''' using delimiters '''','''''';

	RETURN NEXT val_entro;
	
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION view_set(varchar) RETURNS SETOF varchar AS'
DECLARE
		
	sql2		text DEFAULT NULL;
	rec1		record;		
	
BEGIN

	FOR rec1 IN EXECUTE ''SELECT att,valor FROM pg_pila WHERE num!=0 AND valor >= 0'' LOOP
			
		IF sql2 ISNULL THEN
			sql2 := CAST(rec1.att as varchar) || ''='' || rec1.valor;	
		ELSE
			sql2 := sql2 || '' AND ''|| CAST(rec1.att as varchar) || ''='' || rec1.valor;
		END IF;			
	END LOOP;
		
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''viewc1'''''' LOOP
		EXECUTE ''DROP VIEW viewc1'';
	END LOOP;		
	
	IF sql2 IS NOT NULL THEN
		sql2 := ''CREATE VIEW viewc1 AS SELECT * FROM ''||$1||'' WHERE ''||sql2;
		
	ELSE	
		sql2 := ''CREATE VIEW viewc1 AS SELECT * FROM ''||$1;
	END IF;
	
	EXECUTE sql2;
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION mate_gain(integer,varchar) RETURNS SETOF numeric AS' 
DECLARE
	
	sum		integer;
	sum1		integer;
	
	Gan		numeric;
	
	att		varchar DEFAULT '''';
	cad		varchar DEFAULT NULL;
	txt		varchar DEFAULT '''';
		
	Ent		numeric;
	
	rec1		record;
	
BEGIN
				
		txt := ''SELECT att FROM pg_pila'';
		FOR rec1 IN EXECUTE txt LOOP
			IF cad ISNULL THEN
				cad := ''attname !=''''''||rec1.att||'''''''';
			ELSE
				cad := cad ||'' AND attname !=''''''||rec1.att||'''''''';
			END IF;
			att := rec1.att;
		END LOOP;
		
		txt := ''SELECT attname FROM pg_class,pg_attribute WHERE ''
			 ||''pg_class.relname=''''kdd_ent''''''	
			 || '' AND pg_attribute.attrelid =  pg_class.oid AND ''||cad||'' AND attnum >0 ORDER BY attnum'';
		cad := NULL;
		
		FOR rec1 IN EXECUTE txt LOOP
			IF cad ISNULL THEN
				cad := rec1.attname||''=-1'';
			ELSE
				cad := cad||'' AND ''||rec1.attname||''=-1'';
			END IF;
		END LOOP;
		
		IF cad ISNULL THEN
			txt := ''SELECT SUM(count) AS suma FROM viewc1 WHERE ''||att||''!=''''-1'''''';
		ELSE
			txt := ''SELECT SUM(count) AS suma FROM viewc1 WHERE ''||cad||'' AND ''||att||''!=''''-1'''''';
		END IF;
		
		FOR rec1 IN EXECUTE txt LOOP
			sum := rec1.suma;
		END LOOP;
		
		IF cad ISNULL THEN
			txt := ''SELECT ''||att||'' AS at,count,entro FROM viewc1 WHERE ''||att||''!=''''-1'''''';
		ELSE
			txt := ''SELECT ''||att||'' AS at,count,entro FROM viewc1 WHERE ''||cad||'' AND ''
						||att||''!=''''-1'''''';
		END IF;
		

		Gan := 0;
		cad :=NULL;
		sum1 := 0;
		Ent := 0;
		FOR rec1 IN EXECUTE txt LOOP			
	
			IF cad ISNULL THEN
				cad = CAST(rec1.at as bpchar);
				sum1 = rec1.count;
				Ent = rec1.entro;
				
			ELSE
				IF cad = rec1.at THEN
					sum1 := sum1 + rec1.count;
					Ent := Ent + rec1.entro;
					
				ELSE
					cad := rec1.at;
					Gan := Gan + ((CAST(sum1 as numeric)/CAST(sum as numeric))*CAST(Ent as numeric));
			
					sum1 := rec1.count;
					Ent := rec1.entro;
				END IF;
			END IF;	
		END LOOP;
		Gan := Gan + ((CAST(sum1 as numeric)/CAST(sum as numeric))*CAST(Ent as numeric));
	RETURN NEXT Gan;	
	
			
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION mate_tree(integer,integer,integer,varchar) RETURNS SETOF integer AS' 
DECLARE
	con 		integer;	
	numatt	integer;
	i		integer; 
	cp 		integer; 
	nnodos	integer := 0;
	BAN		integer;
	
	Gan		numeric;
	G_min		numeric :=0;
	
	sql		text DEFAULT NULL;	
	sql2		text DEFAULT '''';
	sql4		text DEFAULT '''';
	sql_g		text DEFAULT '''';
	clase		text DEFAULT '''';
	cad		text DEFAULT NULL;
	grp		text DEFAULT '''';
	att		text DEFAULT NULL;
	txt		text DEFAULT '''';
	txt1		text DEFAULT '''';
	rta		text DEFAULT '''';
	
	Ent		datentro%ROWTYPE;
	
	rec1		record;
	rec2		record;
	rec3		record;
	rec_g		record;
BEGIN
     
	clase := $4;	
	i := $1;
	cp := $2;
	
	EXECUTE ''SELECT * FROM view_set(''''kdd_entro'''')'';	


			
		BAN = 0;
		sql := ''SELECT '' || clase || '' AS cl,count(*) AS ct FROM viewc1 GROUP BY '' || clase;
			
		con := 0;							
		FOR rec2 IN EXECUTE sql LOOP				
 			con := con + 1;
		END LOOP;	
			
		IF (con > 1) THEN 
			BAN = 1;
		END IF;
			
		IF (BAN = 1) THEN
		
			FOR rec2 IN EXECUTE ''SELECT relnatts FROM pg_class WHERE pg_class.relname = ''''kdd_ent'''''' LOOP
			END LOOP;
				
			IF (cp= rec2.relnatts) THEN
				BAN := 2;
			END IF;
		END IF;
			
		IF (BAN = 1) THEN		
				
			cad := NULL;	
			FOR rec2 IN EXECUTE ''SELECT att FROM pg_pila'' LOOP
				IF cad ISNULL THEN
					cad := ''attname!=''''''|| rec2.att ||'''''''';
					rta := rec2.att;
				ELSE
					cad := cad || '' AND attname!='''''';
					cad := cad || rec2.att ||'''''''';
					rta := rta || '','' || rec2.att;
				END IF;
			END LOOP;	
				
			sql := ''SELECT attname,attnum FROM pg_class,pg_attribute WHERE ''
			|| ''pg_class.relname=''''viewc1'''' AND pg_attribute.attrelid= pg_class.oid AND ''
			|| cad || '' AND attname!= ''''entro'''' AND attname!= ''''count'''' AND attnum > 0 ORDER BY attnum'';	

			G_min := 999;
			FOR rec2 IN EXECUTE sql LOOP			
		 		EXECUTE ''INSERT INTO pg_pila VALUES(''|| (cp+1) ||'',0,'''''' || rec2.attname || '''''',-1)'';
		
				sql2 := ''SELECT * FROM mate_gain(''||cp+1||'','''''' || clase || '''''')'';	
			
				FOR rec3 IN EXECUTE sql2 LOOP
				END LOOP;
				
				IF rec3.mate_gain < G_min THEN
					G_min := rec3.mate_gain;				
					txt := rec2.attname;
					numatt := rec2.attnum;
					rta := rec2.attname;					
				END IF;
				
				EXECUTE ''DELETE FROM pg_pila WHERE num='' || (cp+1);
			END LOOP;			
			
			
			EXECUTE ''UPDATE mate_nodes SET hijo=''||(i+1)||'' WHERE nodo=''||$3;

			sql := ''SELECT ''||txt||'' AS at FROM viewc1 WHERE ''||txt||''!=''''-1'''' GROUP BY ''||txt;

			FOR rec1 IN EXECUTE sql LOOP		
				i := i + 1;
				EXECUTE ''INSERT INTO mate_nodes VALUES(''||i||'',''||$3||'','''''' || txt || '''''',''||rec1.at||'',-1,''||(i+1)||'',-1)'';									
			END LOOP;		
			EXECUTE ''UPDATE mate_nodes SET herm = -1 WHERE nodo=''||i;	
		
		ELSE	
			
			IF con = 1 OR BAN = 2 THEN
				IF BAN = 0 THEN
					EXECUTE ''UPDATE mate_nodes SET clase=''|| CAST(rec2.cl as int2) ||'' WHERE nodo=''||$3;
					numatt := rec2.cl;
					
				ELSE
					EXECUTE ''UPDATE mate_nodes SET clase=-999 WHERE nodo=''||nnodos;
						numatt := -999;						
				END IF;	
	


				FOR rec2 IN EXECUTE ''	SELECT MAX(id) AS cc FROM mate_rules'' LOOP
					con := rec2.cc + 1;
				END LOOP;
				IF con ISNULL THEN
					con :=1;
				END IF;
					
				sql := ''SELECT att,valor FROM pg_pila WHERE num!=0'';
				FOR rec2 IN EXECUTE sql LOOP
					rta := rec2.att;
					FOR rec3 IN EXECUTE ''SELECT attnum FROM pg_attribute WHERE attname=''''''||rta||'''''''' LOOP
					END LOOP;
						
					sql2 := ''INSERT INTO mate_rules VALUES(''||con||'',''||rec3.attnum||'',''||rec2.valor||'')'';
					EXECUTE sql2;
				END LOOP;

				FOR rec3 IN EXECUTE ''SELECT attnum FROM pg_attribute WHERE attname=''''''||clase||'''''''' LOOP
				END LOOP;				

				EXECUTE ''INSERT INTO mate_rules VALUES(''||con||'',''||rec3.attnum||'',''|| numatt||'')'';
			ELSE
				con := 0;
				FOR rec1 IN EXECUTE ''SELECT * FROM c45_nodes WHERE hijo=''||$3 LOOP
					FOR rec2 IN EXECUTE ''SELECT * FROM c45_nodes WHERE nodo=''||$3 LOOP						
					END LOOP;
					EXECUTE ''UPDATE c45_nodes SET hijo = ''||rec2.herm || '' WHERE hijo=''||$3;
					con := 1;
				END LOOP;
				IF con = 0 THEN
					FOR rec1 IN EXECUTE ''SELECT * FROM c45_nodes WHERE herm=''||$3 LOOP
						FOR rec2 IN EXECUTE ''SELECT * FROM c45_nodes WHERE nodo=''||$3 LOOP						
						END LOOP;
						EXECUTE ''UPDATE c45_nodes SET herm = ''||rec2.herm || '' WHERE hijo=''||$3;						
					END LOOP;
				END IF;
				EXECUTE ''DELETE FROM c45_nodes WHERE nodo=''||$3;

			END IF;
			BAN := 2;
		END IF;	
		EXECUTE ''DELETE FROM pg_pila WHERE num = ''||cp;
	RETURN NEXT BAN;
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION test_rules(varchar) RETURNS SETOF varchar AS '

DECLARE
	
	cad		text DEFAULT NULL;
	atri		text DEFAULT NULL;
	tabla		text DEFAULT NULL;
	rel		text DEFAULT NULL;
	
	
	sql1		varchar DEFAULT NULL;	
	sql2		varchar DEFAULT NULL;	
	sql		varchar DEFAULT NULL;	

	rec_rules	record;	
	rec1		record;
	rec2		record;

	cont		integer;
	att		integer;
	at		integer;
	i		integer DEFAULT 1;
	
	prob		numeric(10,3);
	
BEGIN
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_kdd_rel'''''' LOOP
		EXECUTE ''DROP TABLE pg_kdd_rel'';
	END LOOP;
	EXECUTE ''CREATE TABLE pg_kdd_rel(n int2,rel bpchar)'';
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_pru'''''' LOOP
	END LOOP;	
	IF rec1.relname IS NOT NULL THEN
		tabla := ''kdd_pru'';
	ELSE
		tabla := ''pg_kdd_tmp'';
	END IF;	
	
	FOR rec1 IN EXECUTE ''SELECT relnatts FROM pg_class WHERE pg_class.relname=''''''||tabla||'''''''' LOOP
	END LOOP;
	att := rec1.relnatts;	
	
	cont := 0;
	
	FOR rec_rules IN EXECUTE ''SELECT * FROM ''||$1||''_rules ORDER BY id'' LOOP
		
		at := rec_rules.atributo;
		
		FOR rec1 IN EXECUTE ''SELECT attname FROM pg_class,pg_attribute WHERE pg_class.relname = ''''''||tabla||'''''' AND pg_attribute.attrelid = pg_class.oid AND attnum = ''||at LOOP
		END LOOP;
		
		atri := rec1.attname;
					
		IF rec_rules.atributo = att THEN
			sql1 := sql1 ||'' AND ''||atri ||'' = ''||rec_rules.valor;
			
			FOR rec1 IN EXECUTE sql1 LOOP
				cont := cont + rec1.cc;
			END LOOP;
			
			FOR rec2 IN EXECUTE sql2||'' AND ''||atri ||'' = ''||rec_rules.valor LOOP
				rel := ''[''||CAST(rec2.cc as varchar);
			END LOOP;
			
			FOR rec2 IN EXECUTE sql2 LOOP
				rel := rel||''/''||CAST(rec2.cc as varchar)||'']'';
			END LOOP;
			EXECUTE ''INSERT INTO pg_kdd_rel VALUES(''||i||'',''''''||rel||'''''')'';
			
			sql1 := NULL;
			i := i + 1;
		ELSE
	
			IF sql1 IS NULL THEN
				sql1 := ''SELECT COUNT(*) AS cc FROM ''||tabla||'' WHERE ''||atri ||'' = ''||rec_rules.valor;
				
				sql2 := ''SELECT COUNT(*) AS cc FROM pg_kdd_tmp WHERE ''||atri ||'' = ''||rec_rules.valor;
			ELSE
				sql1 := sql1 ||'' AND ''||atri ||'' = ''|| rec_rules.valor;
				sql2 := sql2 ||'' AND ''||atri ||'' = ''|| rec_rules.valor;
			END IF;	
		END IF;
		
	END LOOP;	
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''kdd_pru'''''' LOOP
		EXECUTE ''DROP TABLE kdd_pru'';
	END LOOP;
	sql := CAST(cont as varchar);
		
	RETURN NEXT sql;
		
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION translate_rules(varchar) RETURNS SETOF varchar AS '
DECLARE
	
	qry_sql		text DEFAULT '''';	
	cad		text DEFAULT NULL;
	cr		text DEFAULT NULL;
	clase		text DEFAULT '''';
	
	rec_at		record;
	rec1		record;
	
BEGIN


	
	cad := ''id bpchar,atributo bpchar,valor bpchar'';
	
	EXECUTE ''COPY ''||$1||''_rules TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE ''||$1||''_rules'';
	EXECUTE ''CREATE TABLE ''||$1||''_rules (''||cad||'')''; 
	EXECUTE ''COPY ''||$1||''_rules FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_rules SET atributo=''''''||rec_at.attname||'''''' WHERE atributo=''''''||rec_at.attnum||'''''''';	
		EXECUTE cad;	
		
	END LOOP;
		
	qry_sql := ''SELECT atributo,valor,discret from kdd_values'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_rules SET valor=''''''||rec_at.valor||'''''' WHERE atributo=''''''||rec_at.atributo||'''''' AND valor=''''''||rec_at.discret||'''''''';	
		EXECUTE cad;
		
	END LOOP;
	
	cad := ''UPDATE ''||$1||''_rules SET valor='''''''' WHERE valor = ''''-999'''''';
	EXECUTE cad;	
	


	cad := ''nodo int2,padre int2,atributo bpchar,valor bpchar,hijo int2, herm int2,clase bpchar'';
	
	EXECUTE ''COPY ''||$1||''_nodes TO ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	EXECUTE ''DROP TABLE ''||$1||''_nodes'';
	EXECUTE ''CREATE TABLE ''||$1||''_nodes (''||cad||'')''; 
	EXECUTE ''COPY ''||$1||''_nodes FROM ''''/tmp/classi.txt'''' using delimiters '''','''' '';
	
	qry_sql := ''SELECT attname, attnum, relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''kdd_ent'''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_nodes SET atributo=''''''||rec_at.attname||'''''' WHERE atributo=''''''||rec_at.attnum||'''''''';	
		EXECUTE cad;
		
		IF (rec_at.attnum = rec_at.relnatts) THEN
			
			clase := rec_at.attname;
			
		END IF;
	END LOOP;
		
	qry_sql := ''SELECT atributo,valor,discret FROM  kdd_values '';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
	
		cad := ''UPDATE ''||$1||''_nodes SET valor=''''''||rec_at.valor||'''''' WHERE atributo=''''''||rec_at.atributo||'''''' AND valor=''''''||rec_at.discret||'''''''';	
		EXECUTE cad;		
		IF rec_at.atributo = clase THEN
			cad := ''UPDATE ''||$1||''_nodes SET clase=''''''||rec_at.valor||'''''' WHERE clase=''''''||rec_at.discret||'''''''';
				EXECUTE cad;		
		END IF;
	END LOOP;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''pg_rangos'''''' LOOP
		EXECUTE ''SELECT * FROM translate_inte(''''''||clase||'''''',''''''||$1||'''''')'';
	END LOOP;	
	
	
	EXECUTE ''DROP TABLE kdd_ent'';	
	
	
	RETURN NEXT ''''''OK'''''';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);


CREATE OR REPLACE FUNCTION translate_inte(varchar,varchar)RETURNS SETOF varchar AS' 
DECLARE
	
	qry_sql		text DEFAULT '''';
	cad		text DEFAULT '''';
	tope		varchar DEFAULT '''';

	rec_at		record;
	rec1		record;
	
	con 		integer;
	
	
BEGIN

		

	
		FOR rec_at IN EXECUTE ''SELECT * FROM pg_rangos'' LOOP
		
			qry_sql := ''UPDATE ''||$2||''_rules SET valor = ''''''||tope||''''''''
				|| ''  WHERE valor =''''''||CAST(rec_at.equivalente as varchar)
				||'''''' AND atributo=''''''||CAST(rec_at.atributo as varchar)||'''''''';
			EXECUTE qry_sql;	   
		
		END LOOP;
	


		FOR rec_at IN EXECUTE ''SELECT * FROM pg_rangos'' LOOP
		
			qry_sql := ''UPDATE ''||$2||''_nodes SET valor = ''''''||tope||''''''''
				|| ''  WHERE valor = ''''''||CAST(rec_at.equivalente as varchar)
				||'''''' AND atributo=''''''||CAST(rec_at.atributo as varchar)||'''''''';
			EXECUTE qry_sql;	   
		
			IF CAST(rec_at.atributo as varchar) = $1 THEN
			
				qry_sql := ''UPDATE ''||cad||'' SET clase = ''''''||tope||''''''''
					|| ''  WHERE clase = ''''''||rec_at.equivalente||'''''''';
				EXECUTE qry_sql;	   
			
			END IF;
		
		END LOOP;
		EXECUTE ''DROP TABLE pg_rangos'';
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);



CREATE OR REPLACE FUNCTION arm_rules(varchar,varchar) RETURNS SETOF varchar AS '
DECLARE
	
	cad		text DEFAULT NULL;
	
	sql1		varchar DEFAULT '''';	
	sql		varchar DEFAULT NULL;	
	att		varchar DEFAULT NULL;	

	rec_rules	record;
	rec1		record;

	re		integer;
BEGIN

	sql1 := NULL;
	
	re := 1;
	
	FOR rec1 IN EXECUTE ''SELECT relname FROM pg_class WHERE relname = ''''reglas'''''' LOOP
		EXECUTE ''DROP TABLE reglas'';
	END LOOP;
	
	EXECUTE ''CREATE TABLE reglas(regla varchar(500))'';

	
	
	FOR rec_rules IN EXECUTE ''SELECT * FROM ''||$2||''_rules ORDER BY id'' LOOP
		att := CAST(rec_rules.atributo as varchar);
		IF att = $1 THEN
			sql1 := sql1 ||'' --> ''||CAST(rec_rules.atributo as varchar) ||'' = ''||CAST(rec_rules.valor as varchar);	
			
			FOR rec1 IN EXECUTE ''SELECT * FROM pg_kdd_rel WHERE n=''||re LOOP
				sql1 :=  sql1||''     ''||CAST(rec1.rel as varchar);
			END LOOP;	
			
			EXECUTE ''INSERT INTO REGLAS(regla) values(''''''||sql1||'''''')'';

			RETURN  NEXT sql1;	
			re := re + 1;
			sql1 := NULL;
		ELSE
			IF sql1 IS NULL THEN
				sql1 := re ||'' - ''||CAST(rec_rules.atributo as varchar) ||'' = ''||CAST(rec_rules.valor as varchar);
			ELSE
				sql1 := sql1 ||'' AND ''||CAST(rec_rules.atributo as varchar)||'' = ''|| CAST(rec_rules.valor as varchar);
			END IF;	
			
			
		END IF;
		
	END LOOP;
	
		
		
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
